// Unknown Cycle, map for Age of empires III (adapted from patch 1.07's Unknow map)
// by/par ECTAGRAINS  (v. 14 June 2006)

void main(void)
{

  // Text
   rmSetStatusText("",0.01);

//  *****************************    options    ********************

	//Nations disponibles (available indian nations)

	string optionNationA = "aztec";
	string optionNationC = "carib";
	string optionNationD = "comanche";
	string optionNationE = "cree";
	string optionNationH = "cherokee";
	string optionNationI = "inca";
	string optionNationJ = "iroquois";
	string optionNationL = "lakota";
	string optionNationM = "maya";
	string optionNationN= "nootka";
	string optionNationS = "seminole";
	string optionNationT = "tupi";

	// declaration de l'utilisation des nations indiennes (attention a l'ortographe des noms)

		rmAllocateSubCivs(12);
		rmSetSubCiv(0,"Aztecs");
		rmSetSubCiv(1, "Caribs");
		rmSetSubCiv(2, "Cherokee");
		rmSetSubCiv(3, "Comanche");
		rmSetSubCiv(4, "Cree");
		rmSetSubCiv(5, "Incas");
		rmSetSubCiv(6, "Iroquois");
		rmSetSubCiv(7, "Lakota");
		rmSetSubCiv(8, "Maya");
		rmSetSubCiv(9, "Nootka");
		rmSetSubCiv(10, "Seminoles");
		rmSetSubCiv(11, "Tupi");
		
	
	// Chances d'avoir tous la meme nation (X to one to have same nation for all)
	int optionOneNation = 20;

	//Chances d'avoir les campements eloignes (x to one to have indians camps not close to town)
	int optionNationsEloignees = 15;

	//distances des villages (distance of indian villages)
	float allieDistanceMin = 25;
	float allieDistanceMax = 60;

	//Chances d'avoir un bonus (one to x/5 to have bonus unit)
	int optionBonus = 80;
	


	// duree des phases de lumiere   (light phases management)
	float DureeLumiere = 225;
	float DureeTransition = 7;


	

  // ************  taille de la carte (map size)  **************************************

	int size=2.0*sqrt(cNumberNonGaiaPlayers*20000);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	rmSetMapElevationParameters(cElevTurbulence, 0.02, rmRandFloat(2,5), 0.7, 8.0);

// ******************************* type de carte (Base terrain) *********************

	float baseTerrain = rmRandFloat(0,1);
	int amazonMap = -1;
	int carolinaMap = -1;
	int saguenayMap = -1;
	int rockiesMap = -1;
	int sonoraMap = -1;
	string riverName = "";
	string oceanName = "";
	string pondName = "";
	string cliffName = "";
	string forestName = "";
	string landName = "";
	string treeName = "";
	string critterOneName = "";
	string critterTwoName = "";
	string livestockName = "";
	string fishName = "";
	string whaleName = "";

	if(baseTerrain < 0.2)
	{
		rmEchoInfo("Amazon terrain");
		amazonMap = 1;
		rmSetBaseTerrainMix("amazon grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("yucatan");
		rmSetMapType("tropical");
		rmSetMapType("land");
	  	riverName = "Amazon River";
		oceanName = "Amazon River Basin";
		pondName = "Bayou";
		cliffName = "Amazon";
		forestName = "Amazon Rain Forest";
		landName = "amazon grass";
		treeName = "treeAmazon";
		critterOneName = "capybara";
		critterTwoName = "tapir";
		livestockName = "cow";
		fishName = "fishMahi";
		whaleName = "humpbackWhale";
	}

	else if(baseTerrain < 0.35)
	{
		rmEchoInfo("Carolina terrain");
		carolinaMap = 1;
		rmSetBaseTerrainMix("carolina_grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("carolina");
		rmSetMapType("grass");
		rmSetMapType("land");
		riverName = "Pampas River";
		oceanName = "Atlantic Coast";
		pondName = "Texas Pond";
		cliffName = "Carolina Inland";
		forestName = "Carolina Pine Forest";
		landName = "carolina_grass";
		treeName = "treeCarolinaGrass";
		critterOneName = "turkey";
		critterTwoName = "deer";
		livestockName = "sheep";
		fishName = "fishCod";
		whaleName = "humpbackWhale";
	}

	else if(baseTerrain < 0.5)
	{
		rmEchoInfo("Saguenay terrain");
		saguenayMap = 1;
		rmSetBaseTerrainMix("saguenay tundra");
		rmTerrainInitialize("saguenay\ground1_sag",6);
		rmSetMapType("saguenay");
		rmSetMapType("grass");
		rmSetMapType("land");
	  	riverName = "Amazon River";
		oceanName = "Hudson Bay";
		pondName = "Saguenay Lake";
		cliffName = "New England Inland";
		forestName = "Saguenay Forest";
		landName = "saguenay tundra";
		treeName = "treeSaguenay";
		critterOneName = "elk";
		critterTwoName = "moose";
		livestockName = "sheep";
		fishName = "fishSalmon";
		whaleName = "minkeWhale";
	}

	else if(baseTerrain < 0.8)
	{
		rmEchoInfo("Rockies terrain");
		rockiesMap = 1;
		rmSetBaseTerrainMix("rockies_snow");
		rmTerrainInitialize("rockies\groundsnow1_roc", 6);	
		rmSetMapType("rockies");
		rmSetMapType("land");
		rmSetLightingSet("rockies");
		riverName = "Yukon River";
		oceanName = "Great Lakes Ice";
		pondName = "Great Lakes Ice";
		cliffName = "Rocky Mountain2";
		forestName = "Rockies Snow Forest";
		landName = "rockies_snow";
		treeName = "treeRockies";
		critterOneName = "caribou";
		critterTwoName = "muskOx";
		livestockName = "cow";
		fishName = "fishSardine";
		whaleName = "beluga";
	}

	else
	{
		rmEchoInfo("Sonora terrain");
		sonoraMap = 1;
		rmSetBaseTerrainMix("sonora_dirt");
		rmTerrainInitialize("sonora\ground2_son", 6);
		rmSetMapType("sonora");
		rmSetMapType("grass");
		rmSetMapType("land");
		riverName = "Pampas River";
		oceanName = "Great Lakes";
		pondName = "Great Lakes"; 
		cliffName = "Sonora";
		forestName = "Sonora Forest";
		landName = "sonora_dirt";
		treeName = "treeSonora";
		critterOneName = "turkey";
		critterTwoName = "rhea";
		livestockName = "sheep";
		fishName = "fishTarpon";
		whaleName = "humpbackWhale";

	}

	   rmSetStatusText("", 0.1);



// ********************** Classes **********************

	int classPlayer=rmDefineClass("player");
	int classNatives=rmDefineClass("natives");
	int classCanyon=rmDefineClass("canyon");
	int pondClass=rmDefineClass("pond");
	rmDefineClass("startingUnit");
	rmDefineClass("classForest");



// ********************** CONTRAINTES    (Constraints) **********************

	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 20.0);
	int playerAvoidImpassableLand = rmCreateTerrainDistanceConstraint("player avoid impassable land", "Land", false, 18.0);
	int mediumAvoidImpassableLand = rmCreateTerrainDistanceConstraint("slightly avoid impassable", "Land", false, 12.0);
	int shortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("just barely avoid impassable", "Land", false, 4.0);
	int TCAvoidImpassableLand = rmCreateTerrainDistanceConstraint("TCs vs impassable land", "Land", false, 8.0);
	int avoidPlayers = rmCreateClassDistanceConstraint("stay away from players medium", classPlayer, 30.0);

	// float optionEloignement = 15; 
	// int avoidPlayersSiEloignes = rmCreateClassDistanceConstraint("distance si camps isoles", classPlayer, optionEloignement);

	int avoidPlayersEntreEux = rmCreateClassDistanceConstraint("joueurs eloignes entre eux", classPlayer, 40.0);
	int avoidPlayersFar = rmCreateClassDistanceConstraint("stay away from players far", classPlayer, 50.0);
	
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route sockets", "sockettraderoute", 15.0);
	
	int TCAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("TC vs trade route", 4.0);
	int TCAvoidTradeRouteSocket = rmCreateTypeDistanceConstraint("TC avoid trade route sockets", "sockettraderoute", 8.0);
	int avoidNatives = rmCreateClassDistanceConstraint("stay away from natives", classNatives, 40.0);
	// int nativesAvoidPlayers = rmCreateClassDistanceConstraint("natives vs. players", classPlayer, 50.0);
   int edgeConstraint=rmCreatePieConstraint("continent avoids edge",  0.5, 0.5, 0, rmGetMapXSize()-20, 0, 0, 0);
	int avoidCanyon = rmCreateClassDistanceConstraint("don't place on mesa where you can't path", classCanyon, 2.0);
   int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 30.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
	int avoidTC=rmCreateTypeDistanceConstraint("vs. TC", "TownCenter", 20.0);
	int avoidCW=rmCreateTypeDistanceConstraint("vs. CW", "CoveredWagon", 20.0);
   int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 30.0);
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "abstractWhale", 25.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
   int avoidFood = rmCreateTypeDistanceConstraint("food avoids food", "food", 40.0);
	int avoidSilver = rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 40.0);

   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);



// ********************** Land and Water Configuration ************************

	int allLand = 1;
	int riverExists = -1;
	int oceanMiddle = -1;
	int oceanOffCenter = -1;
	int oceanRing = -1;
	int plateauMiddle = -1;
	int forestMiddle = -1;
	int blockedMiddle = -1; // used to determine if trade route should be a circle
	
	float landConfig = rmRandFloat(0,1);

// ******************** Land Only ********************
	if(landConfig < 0.15)
		rmEchoInfo("just land");

// ********************* River Across Middle ***************************
	else if(landConfig < 0.35)
	{
		rmEchoInfo("river exists");
		allLand = -1;
		riverExists = 1;
		int unknownRiver = rmRiverCreate(-1, riverName, 30, 15, 5, 8);
		float riverPosition = rmRandFloat(0,1);

		// Spin river randomly around the edge		
		if(riverPosition < 0.12)
			rmRiverSetConnections(unknownRiver, 0.0, 0.5, 1.0, 0.5);
		else if(riverPosition < 0.24)
			rmRiverSetConnections(unknownRiver, 0.0, 0.0, 1.0, 1.0);
		else if(riverPosition < 0.36)
			rmRiverSetConnections(unknownRiver, 0.5, 0.0, 0.5, 1.0);
		else if(riverPosition < 0.48)
			rmRiverSetConnections(unknownRiver, 0.0, 1.0, 1.0, 0.0);
		else if(riverPosition < 0.60)
			rmRiverSetConnections(unknownRiver, 0.0, 0.25, 1.0, 0.75);
		else if(riverPosition < 0.72)
			rmRiverSetConnections(unknownRiver, 0.0, 0.75, 1.0, 0.25);
		else if(riverPosition < 0.84)
			rmRiverSetConnections(unknownRiver, 0.25, 0.0, 0.75, 1.0);
		else
			rmRiverSetConnections(unknownRiver, 0.75, 0.0, 0.25, 1.0);
		
		// River always has 2 shallows and usually 3
		rmRiverSetShallowRadius(unknownRiver, rmRandInt(10, 12));
		rmRiverAddShallow(unknownRiver, rmRandFloat(0.1, 0.35)); 

		if(rmRandFloat(0,1) < 0.66)
		{
			rmRiverSetShallowRadius(unknownRiver, rmRandInt(10, 12));
			rmRiverAddShallow(unknownRiver, 0.5);
		}

		rmRiverSetShallowRadius(unknownRiver, rmRandInt(10, 12));
		rmRiverAddShallow(unknownRiver, rmRandFloat(0.65, 0.95));
		rmRiverSetBankNoiseParams(unknownRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0);

		rmRiverBuild(unknownRiver);
	}

// ******************** Great Lakes Style Ocean **************************
	else if(landConfig < 0.45)
	{
		rmEchoInfo("ocean in middle");
		allLand = -1;
		oceanMiddle = 1;
		blockedMiddle = 1;

		// But don't build ocean every single time
		if(rmRandFloat(0,1) < 0.9)
		{
			int lakeOfTheUnknown=rmCreateArea("big lake in middle");
			rmSetAreaWaterType(lakeOfTheUnknown, oceanName);
			if(rmRandFloat(0,1) < 0.6)
			{
				rmSetAreaSize(lakeOfTheUnknown, 0.07, 0.15);
				rmEchoInfo("larger lake");
			}
			else
			{
				rmSetAreaSize(lakeOfTheUnknown, 0.02, 0.05);
				rmEchoInfo("smaller lake");
			}
			rmSetAreaLocation(lakeOfTheUnknown, 0.5, 0.5);
			rmAddAreaConstraint(lakeOfTheUnknown, avoidPlayers);
			rmSetAreaSmoothDistance(lakeOfTheUnknown, 50);
			rmSetAreaCoherence(lakeOfTheUnknown, 0.25);
		}
	} 

// Build the lake later to avoid players

// ************************ Ocean dans un coin - ocean in a corner *************
	else if(landConfig < 0.55)
	{
		rmEchoInfo("ocean off center");
		allLand = -1;
		oceanOffCenter = 1;
		float bayPosition = rmRandFloat(0,1);
		int unknownBay=rmCreateArea("big bay on edge");
		rmSetAreaWaterType(unknownBay, oceanName);
		rmSetAreaWarnFailure(unknownBay, false);
		rmSetAreaSize(unknownBay, 0.08, 0.15);

		// Spin bay randomly around the edge		
		if(bayPosition < 0.12)
			rmSetAreaLocation(unknownBay, 0.0, 0.0);
		else if(bayPosition < 0.24)
			rmSetAreaLocation(unknownBay, 0.0, 0.5);
		else if(bayPosition < 0.36)
			rmSetAreaLocation(unknownBay, 0.0, 1.0);
		else if(bayPosition < 0.48)
			rmSetAreaLocation(unknownBay, 0.5, 1.0);
		else if(bayPosition < 0.60)
			rmSetAreaLocation(unknownBay, 1.0, 1.0);
		else if(bayPosition < 0.72)
			rmSetAreaLocation(unknownBay, 1.0, 0.5);
		else if(bayPosition < 0.84)
			rmSetAreaLocation(unknownBay, 1.0, 0.0);
		else
			rmSetAreaLocation(unknownBay, 0.5, 0.0);

  		rmSetAreaObeyWorldCircleConstraint(unknownBay, false);
		rmAddAreaConstraint(unknownBay, avoidPlayers);
	   rmSetAreaSmoothDistance(unknownBay, 50);
	   rmSetAreaCoherence(unknownBay, 0.15);
	}

	// Build bay later to avoid players


// ******************  Grande Ile (big island) ***********************
	else if(landConfig < 0.65)
	{
		rmEchoInfo("ocean ring");
		allLand = -1;
		oceanRing = 1;

		int worldOcean=rmCreateArea("ocean that covers whole map");
		rmSetAreaWaterType(worldOcean, oceanName);
		rmSetAreaSize(worldOcean, 1, 1);
		rmSetAreaLocation(worldOcean, 0.5, 0.5);
		rmSetAreaWarnFailure(worldOcean, false);
      rmSetAreaObeyWorldCircleConstraint(worldOcean, false);
		rmBuildArea(worldOcean);

		int continent=rmCreateArea("island continent in ocean");
		rmSetAreaMix(continent, landName);
      rmSetAreaElevationType(continent, cElevTurbulence);
      rmSetAreaElevationVariation(continent, 4.0);
      rmSetAreaBaseHeight(continent, 3.5);
      rmSetAreaElevationMinFrequency(continent, 0.09);
      rmSetAreaElevationOctaves(continent, 3);
      rmSetAreaElevationPersistence(continent, 0.2);
		rmSetAreaElevationNoiseBias(continent, 1);
		rmSetAreaSize(continent, 0.32, 0.32);
		rmSetAreaLocation(continent, 0.5, 0.5);
	   rmSetAreaSmoothDistance(continent, 50);
	   rmSetAreaCoherence(continent, 0.25);
		rmAddAreaConstraint(continent, edgeConstraint);
		rmBuildArea(continent);
	}

//   ********************  Plateau / Canyon ********************
	else if(landConfig < 0.80)
	{
		rmEchoInfo("plateau in middle");
		allLand = -1;
		plateauMiddle = 1;
		blockedMiddle = 1;
		int centerMesa=rmCreateArea("large mesa or canyon in middle");
		rmSetAreaSize(centerMesa, 0.05, 0.12);  
		rmSetAreaCliffType(centerMesa, cliffName);

		if(rmRandFloat(0,1) < 0.8)
		{		
			rmSetAreaCliffEdge(centerMesa, 1, 1.0, 0.1, 1.0, 0);
			rmAddAreaToClass(centerMesa, classCanyon);
			rmEchoInfo("no ramps");	
		}
		else
		{
			rmSetAreaCliffEdge(centerMesa, 4, 0.2, 0.0, 1.0, 0); 
			rmEchoInfo("ramps");
		}
		if(rmRandFloat(0,1) < 0.6)
			rmSetAreaCliffHeight(centerMesa, rmRandInt(6,8), 1.0, 1.0);
		else
			rmSetAreaCliffHeight(centerMesa, rmRandInt(-8,-6), 1.0, 1.0);
		rmSetAreaMinBlobs(centerMesa, 3);
		rmSetAreaMaxBlobs(centerMesa, 5);
		rmSetAreaMinBlobDistance(centerMesa, 3.0);
		rmSetAreaMaxBlobDistance(centerMesa, 5.0);
		rmSetAreaCoherence(centerMesa, 0.3);
		rmSetAreaLocation(centerMesa, 0.5, 0.5);
	   rmSetAreaSmoothDistance(centerMesa, 20);
		rmAddAreaConstraint(centerMesa, avoidPlayers); 
	}

// Build canyon later to avoid players

// ******************** Foret au centre (forest in the middle) ********************
	else
	{
		rmEchoInfo("forest in middle");
		allLand = -1;
		forestMiddle = 1;
		int greatUnknownForest=rmCreateArea("large central forest");
      rmSetAreaWarnFailure(greatUnknownForest, false);
      rmSetAreaSize(greatUnknownForest, 0.08, 0.08);
      rmSetAreaForestType(greatUnknownForest, forestName);
      rmSetAreaForestDensity(greatUnknownForest, 0.8);
      rmSetAreaForestClumpiness(greatUnknownForest, 0.6);
      rmSetAreaForestUnderbrush(greatUnknownForest, 0.0);
      rmSetAreaMinBlobs(greatUnknownForest, 1);
      rmSetAreaMaxBlobs(greatUnknownForest, 5);
      rmSetAreaMinBlobDistance(greatUnknownForest, 16.0);
      rmSetAreaMaxBlobDistance(greatUnknownForest, 70.0);
      rmSetAreaCoherence(greatUnknownForest, 0.15);
      rmSetAreaSmoothDistance(greatUnknownForest, 0);
      rmAddAreaToClass(greatUnknownForest, rmClassID("classForest"));
		rmSetAreaLocation(greatUnknownForest, 0.5, 0.5);
      rmAddAreaConstraint(greatUnknownForest, avoidPlayers); 
	}
	
// Build forest later to avoid players


	// Text
   rmSetStatusText("", 0.20);


// ******************** Placements des joueurs (Player Configurations) ********************


	if (oceanMiddle == 1)
	{
		rmPlacePlayersCircular(0.38, 0.42, 0);
		rmEchoInfo("players nearer edge because ocean in middle");
	}
	else if(oceanRing == 1)
	{
		rmPlacePlayersCircular(0.23, 0.28, 0);
		
	}
	else if(oceanOffCenter == 1)
	{
		rmPlacePlayersCircular(0.25, 0.30, 0);
		
	}
	else
	{
		rmPlacePlayersCircular(0.25, 0.45, 0);
		rmEchoInfo("players can be farther from edge");
	}
	

//	float playerFraction = rmAreaTilesToFraction(1000);
	float playerFraction = rmAreaTilesToFraction(1200); 
//	This fixes no TC on 2P maps

	for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);
      // Assign to the player.
      rmSetPlayerArea(i, id);
      // Set the size.
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, avoidPlayersEntreEux);
	rmSetAreaCoherence(id, 0.35);
	   rmSetAreaSmoothDistance(id, 20);
		rmAddAreaConstraint(id, playerAvoidImpassableLand);
		rmSetAreaLocPlayer(id, i);
		rmSetAreaWarnFailure(id, false);
   }
	rmBuildAllAreas();

	
   rmSetStatusText("", 0.30);


// ************** Route commerciale (Trade Route) **************

	int tradeRouteID = rmCreateTradeRoute();

   int socketID=rmCreateObjectDef("sockets for Trade Route");

	float XStart = -1;
	float ZStart = -1;
	float XStop = -1;
	float ZStop = -1;
	float routePosition = rmRandFloat(0,1);

   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	rmAddObjectDefConstraint(socketID, shortAvoidImpassableLand);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 8.0);
	rmAddClosestPointConstraint(shortAvoidImpassableLand);
   vector tradeRoutePoint = cOriginVector;

	// Trade route circular if center mesa or ocean, else linear
	if(blockedMiddle == 1)
	{
		tradeRoutePoint = rmFindClosestPoint(0.08, 0.55, 30);
		rmAddTradeRouteWaypoint(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)));
		tradeRoutePoint = rmFindClosestPoint(0.20, 0.83, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.45, 0.93, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.67, 0.89, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.78, 0.78, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.84, 0.70, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.86, 0.68, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.88, 0.40, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.81, 0.23, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.70, 0.10, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.50, 0.08, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.30, 0.15, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.15, 0.23, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
		tradeRoutePoint = rmFindClosestPoint(0.08, 0.55, 30);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);

	}
	else // nothing big in middle so go linear
	{
		// If continet, scoot linear trade route in a bit
		if(oceanRing == 1)
		{
			// Spin trade route points around edge
			if(routePosition < 0.12)
			{
				XStart = 0.25;
				ZStart = 0.5;
				XStop = 0.75;
				ZStop = 0.5;
			}
			else if(routePosition < 0.24)
			{
				XStart = 0.25;
				ZStart = 0.25;
				XStop = 0.75;
				ZStop = 0.75;
			}
			else if(routePosition < 0.36)
			{
				XStart = 0.5;
				ZStart = 0.25;
				XStop = 0.5;
				ZStop = 0.75;
			}
			else if(routePosition < 0.48)
			{
				XStart = 0.25;
				ZStart = 0.75;
				XStop = 0.75;
				ZStop = 0.25;
			}
			else if(routePosition < 0.60)
			{
				XStart = 0.25;
				ZStart = 0.25;
				XStop = 0.75;
				ZStop = 0.75;
			}
			else if(routePosition < 0.72)
			{	
				XStart = 0.25;
				ZStart = 0.75;
				XStop = 0.75;
				ZStop = 0.25;
			}
			else if(routePosition < 0.84)
			{
				XStart = 0.25;
				ZStart = 0.25;
				XStop = 0.75;
				ZStop = 0.75;
			}
			else
			{
				XStart = 0.75;
				ZStart = 0.25;
				XStop = 0.25;
				ZStop = 0.75;
			}
		}
		else
		// Otherwise extend trade route to edge
		{
			// Spin trade route points around edge
			if(routePosition < 0.12)
			{
				XStart = 0.0;
				ZStart = 0.5;
				XStop = 1.0;
				ZStop = 0.5;
			}
			else if(routePosition < 0.24)
			{
				XStart = 0.0;
				ZStart = 0.0;
				XStop = 1.0;
				ZStop = 1.0;
			}
			else if(routePosition < 0.36)
			{
				XStart = 0.5;
				ZStart = 0.0;
				XStop = 0.5;
				ZStop = 1.0;
			}
			else if(routePosition < 0.48)
			{
				XStart = 0.0;
				ZStart = 1.0;
				XStop = 1.0;
				ZStop = 0.0;
			}
			else if(routePosition < 0.60)
			{
				XStart = 0.0;
				ZStart = 0.25;
				XStop = 1.0;
				ZStop = 0.75;
			}
			else if(routePosition < 0.72)
			{	
				XStart = 0.0;
				ZStart = 0.75;
				XStop = 1.0;
				ZStop = 0.25;
			}
			else if(routePosition < 0.84)
			{
				XStart = 0.25;
				ZStart = 0.0;
				XStop = 0.75;
				ZStop = 1.0;
			}
			else
			{
				XStart = 0.75;
				ZStart = 0.0;
				XStop = 0.25;
				ZStop = 1.0;
			}
		}

		// Assign trade route waypoints
		tradeRoutePoint = rmFindClosestPoint(XStart, ZStart, 100.0);
		rmAddTradeRouteWaypoint(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)));
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.5, 0.5, 6, 6);
		tradeRoutePoint = rmFindClosestPoint(XStop, ZStop, 100.0);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)), 4, 6);
	}	

   bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
   if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route");  

   // add the sockets along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.20);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	// If continent, then 2 slots. Otherwise 3 or 4.
	if(oceanRing < 1)
	{
		if(rmRandFloat(0,1) < 0.4)
		{
			socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
			rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		}
		else
		{
			socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.40);
			rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
			socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.60);
			rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		}
	}

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.80);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	rmClearClosestPointConstraints();


	
   rmSetStatusText("", 0.4);

// ************** Starting Units **************

	int startingTCID= rmCreateObjectDef("startingTC");
	if (rmGetNomadStart())
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1);
	else
		rmAddObjectDefItem(startingTCID, "townCenter", 1);
	rmSetObjectDefMinDistance(startingTCID, 0.0);
	rmSetObjectDefMaxDistance(startingTCID, 20.0);
	rmAddObjectDefConstraint(startingTCID, TCAvoidImpassableLand);
	rmAddObjectDefConstraint(startingTCID, TCAvoidTradeRoute);
	rmAddObjectDefConstraint(startingTCID, TCAvoidTradeRouteSocket);
	rmAddObjectDefToClass(startingTCID, rmClassID("player"));

	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 8.0);
	rmSetObjectDefMaxDistance(startingUnits, 14.0);
	rmAddObjectDefConstraint(startingUnits, shortAvoidImpassableLand);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));

// Place Starting Units now so other stuff can avoid them
	for(i=1; <cNumberPlayers)
	{
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}

	// Text
   rmSetStatusText("", 0.5);


//**************** bonus de depart (start bonus)  ***********************


string BonusUnit = "SPCSignalFireLit";  		 // feu de signalisation
int BonusRandom = rmRandInt (1,optionBonus);

if (BonusRandom == 1)
	BonusUnit = "Coureur";
if (BonusRandom == 2)
	BonusUnit = "CoureurCree";
if (BonusRandom == 3)
	BonusUnit = "NatMedicineMan";  	// soigneur indien
if (BonusRandom == 4)
	BonusUnit = "Missionary";           	// missionnaire
if (BonusRandom == 5)
	BonusUnit = "OutpostWagon";               
if (BonusRandom == 6)
	BonusUnit = "Surgeon";            	// chirurgien
if (BonusRandom == 7)
	BonusUnit = "Envoy";             	// Emissaire
if (BonusRandom == 8)
	BonusUnit = "Pirate";               
if (BonusRandom == 9)
	BonusUnit = "Priest";               
if (BonusRandom == 12)
	BonusUnit = "IGCFlagBearer";         	 // porte etendard 2
if (BonusRandom == 14)
	BonusUnit = "IGCDrummer";                  //    Tambour 2 
if (BonusRandom == 15)
	BonusUnit = "NativeVillager";               
if (BonusRandom == 16)
	BonusUnit = "SettlerWagon";               	// chariot de colon allemand
if (BonusRandom == 17)
	BonusUnit = "NativeVillager";               
if (BonusRandom == 18)
	BonusUnit = "Boneguard";               	// Garde des reliques
if (BonusRandom == 19)
	BonusUnit = "BoneguardAge2";              //    Garde des reliques
if (BonusRandom == 20)
	BonusUnit = "Crossbowman";	
if (BonusRandom == 22)
	BonusUnit = "ExplorerDog";
if (BonusRandom == 23)
	BonusUnit = "Crossbowman";

 
int operationBonus=rmCreateObjectDef("bonus du debut");
rmAddObjectDefItem(operationBonus, BonusUnit, 1, 0.0);
rmSetObjectDefMinDistance(operationBonus, 2.0);
rmSetObjectDefMaxDistance(operationBonus, 3.0);
rmAddObjectDefConstraint(operationBonus, avoidAll);
for(i=1; <cNumberPlayers)
	{
	rmPlaceObjectDefAtLoc(operationBonus, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}




// ************** nation indienne soumise (one Native Nation per player) **************



string nationAlliee1 = optionNationL;
string nationAlliee2 = optionNationA;
string nationAlliee3 = optionNationS;
string nationAlliee4 = optionNationI;
string nationAlliee5 = optionNationN;
string nationAlliee6 = optionNationJ;
string nationAlliee7 = optionNationM;
string nationAlliee8 = optionNationC;

int allie1 = -1;
int allie2 = -1;
int allie3 = -1;
int allie4 = -1;
int allie5 = -1;
int allie6 = -1;
int allie7 = -1;
int allie8 = -1;
int villageAspect = rmRandInt(1,5);


// preparation d'une valeur aleatoire eauTerre
 
int eauTerre = 2;
 if (riverExists == 1 || forestMiddle == 1)
	eauTerre = 3;

if (allLand == 1 || plateauMiddle == 1)
	eauTerre = 1;


// choix des nations selon le type de cartes et composition eau terre


// si Saguenay ou Caroline (if saguenay or Carolina)
if (eauTerre == 2)
{
		nationAlliee1 = optionNationA;
		nationAlliee2 = optionNationS;
		nationAlliee3 = optionNationM;
		nationAlliee4 = optionNationL;
		nationAlliee5 = optionNationI;
		nationAlliee6 = optionNationN;
		nationAlliee7 = optionNationC;
		nationAlliee8 = optionNationT;
}

if (eauTerre == 3)
{
		nationAlliee1 = optionNationS;
		nationAlliee2 = optionNationM;
		nationAlliee3 = optionNationC;
		nationAlliee4 = optionNationA;
		nationAlliee5 = optionNationL;
		nationAlliee6 = optionNationI;
		nationAlliee7 = optionNationT;
		nationAlliee8 = optionNationH;
}



// si Amazonie
if (amazonMap == 1 && eauTerre == 1)
{
		nationAlliee1 = optionNationM;
		nationAlliee2 = optionNationC;
		nationAlliee3 = optionNationT;
		nationAlliee4 = optionNationS;
		nationAlliee5 = optionNationA;
		nationAlliee6 = optionNationL;
		nationAlliee7 = optionNationH;
		nationAlliee8 = optionNationE;
}



if (amazonMap == 1 && eauTerre == 2)
{
		nationAlliee1 = optionNationC;
		nationAlliee2 = optionNationT;
		nationAlliee3 = optionNationH;
		nationAlliee4 = optionNationM;
		nationAlliee5 = optionNationS;
		nationAlliee6 = optionNationA;
		nationAlliee7 = optionNationE;
		nationAlliee8 = optionNationD;
}

if (amazonMap == 1 && eauTerre == 3)
{
		nationAlliee1 = optionNationT;
		nationAlliee2 = optionNationH;
		nationAlliee3 = optionNationE;
		nationAlliee4 = optionNationC;
		nationAlliee5 = optionNationM;
		nationAlliee6 = optionNationS;
		nationAlliee7 = optionNationD;
		nationAlliee8 = optionNationJ;
}


// si Sonora
if (sonoraMap == 1 && eauTerre == 1)
{
		nationAlliee1 = optionNationH;
		nationAlliee2 = optionNationE;
		nationAlliee3 = optionNationD;
		nationAlliee4 = optionNationT;
		nationAlliee5 = optionNationC;
		nationAlliee6 = optionNationM;
		nationAlliee7 = optionNationJ;
		nationAlliee8 = optionNationN;
}

if (sonoraMap == 1 && eauTerre == 2)
{
		nationAlliee1 = optionNationE;
		nationAlliee2 = optionNationD;
		nationAlliee3 = optionNationJ;
		nationAlliee4 = optionNationH;
		nationAlliee5 = optionNationT;
		nationAlliee6 = optionNationC;
		nationAlliee7 = optionNationN;
		nationAlliee8 = optionNationI;
}

if (sonoraMap == 1 && eauTerre == 3)
{
		nationAlliee1 = optionNationD;
		nationAlliee2 = optionNationJ;
		nationAlliee3 = optionNationN;
		nationAlliee4 = optionNationE;
		nationAlliee5 = optionNationH;
		nationAlliee6 = optionNationT;
		nationAlliee7 = optionNationI;
		nationAlliee8 = optionNationL;
}


// Si Rocheuses (rockies)

if (rockiesMap == 1 && eauTerre == 1)
{
		nationAlliee1 = optionNationJ;
		nationAlliee2 = optionNationN;
		nationAlliee3 = optionNationI;
		nationAlliee4 = optionNationD;
		nationAlliee5 = optionNationE;
		nationAlliee6 = optionNationH;
		nationAlliee7 = optionNationL;
		nationAlliee8 = optionNationA;
}

if (rockiesMap == 1 && eauTerre == 2)
{
		nationAlliee1 = optionNationN;
		nationAlliee2 = optionNationI;
		nationAlliee3 = optionNationL;
		nationAlliee4 = optionNationJ;
		nationAlliee5 = optionNationD;
		nationAlliee6 = optionNationE;
		nationAlliee7 = optionNationA;
		nationAlliee8 = optionNationS;
}

if (rockiesMap == 1 && eauTerre == 3)
{
		nationAlliee1 = optionNationI;
		nationAlliee2 = optionNationL;
		nationAlliee3 = optionNationA;
		nationAlliee4 = optionNationN;
		nationAlliee5 = optionNationJ;
		nationAlliee6 = optionNationD;
		nationAlliee7 = optionNationS;
		nationAlliee8 = optionNationM;
}


// petite chance que tous la meme tribu  (little chance that every player has the same allied)
if (rmRandInt (1,optionOneNation) == 1)
	{
		nationAlliee2 = nationAlliee1;
		nationAlliee3 = nationAlliee1;
		nationAlliee4 = nationAlliee1;
		nationAlliee5 = nationAlliee1;
		nationAlliee6 = nationAlliee1;
		nationAlliee7 = nationAlliee1;
		nationAlliee8 = nationAlliee1;
		
	}



// petite chance que les campements indiens soient isoles (little chance that indian camps are not close)
if (rmRandInt (1,optionNationsEloignees) == 1)
	{
		allieDistanceMin = 100;
		allieDistanceMax = 140;
		// optionEloignement = 80; 
		nationAlliee1 = nationAlliee2;
		nationAlliee3 = nationAlliee2;
		nationAlliee4 = nationAlliee2;
		nationAlliee5 = nationAlliee2;
		nationAlliee6 = nationAlliee2;
		nationAlliee7 = nationAlliee2;
		nationAlliee8 = nationAlliee2;
}







// Creation des villages indiens (indian villages creation)

allie1 = rmCreateGrouping("allie joueur 1", "native "+ nationAlliee1 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie1, allieDistanceMin);
	rmSetGroupingMaxDistance(allie1, allieDistanceMax);
	rmAddGroupingToClass(allie1, rmClassID("natives"));
	rmAddGroupingConstraint(allie1, avoidImpassableLand);
	rmAddGroupingConstraint(allie1, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie1, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie1, avoidNatives);
	rmAddGroupingConstraint(allie1, avoidCanyon);
	rmPlaceGroupingAtLoc(allie1, 1, rmPlayerLocXFraction(1), rmPlayerLocZFraction(1));

allie2 = rmCreateGrouping("allie joueur 2", "native "+ nationAlliee2 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie2, allieDistanceMin);
	rmSetGroupingMaxDistance(allie2, allieDistanceMax);
	rmAddGroupingToClass(allie2, rmClassID("natives"));
	rmAddGroupingConstraint(allie2, avoidImpassableLand);
	rmAddGroupingConstraint(allie2, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie2, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie2, avoidNatives);
	rmAddGroupingConstraint(allie2, avoidCanyon);
	rmPlaceGroupingAtLoc(allie2, 2, rmPlayerLocXFraction(2), rmPlayerLocZFraction(2));

allie3 = rmCreateGrouping("allie joueur 3", "native "+ nationAlliee3 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie3, allieDistanceMin);
	rmSetGroupingMaxDistance(allie3, allieDistanceMax);
	rmAddGroupingToClass(allie3, rmClassID("natives"));
	rmAddGroupingConstraint(allie3, avoidImpassableLand);
	rmAddGroupingConstraint(allie3, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie3, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie3, avoidNatives);
	rmAddGroupingConstraint(allie3, avoidCanyon);
	rmPlaceGroupingAtLoc(allie3, 3, rmPlayerLocXFraction(3), rmPlayerLocZFraction(3));

allie4 = rmCreateGrouping("allie joueur 4", "native "+ nationAlliee4 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie4, allieDistanceMin);
	rmSetGroupingMaxDistance(allie4, allieDistanceMax);
	rmAddGroupingToClass(allie4, rmClassID("natives"));
	rmAddGroupingConstraint(allie4, avoidImpassableLand);
	rmAddGroupingConstraint(allie4, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie4, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie4, avoidNatives);
	rmAddGroupingConstraint(allie4, avoidCanyon);
	rmPlaceGroupingAtLoc(allie4, 4, rmPlayerLocXFraction(4), rmPlayerLocZFraction(4));

allie5 = rmCreateGrouping("allie joueur 5", "native "+ nationAlliee5 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie5, allieDistanceMin);
	rmSetGroupingMaxDistance(allie5, allieDistanceMax);
	rmAddGroupingToClass(allie5, rmClassID("natives"));
	rmAddGroupingConstraint(allie5, avoidImpassableLand);
	rmAddGroupingConstraint(allie5, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie5, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie5, avoidNatives);
	rmAddGroupingConstraint(allie5, avoidCanyon);
	rmPlaceGroupingAtLoc(allie5, 5, rmPlayerLocXFraction(5), rmPlayerLocZFraction(5));

allie6 = rmCreateGrouping("allie joueur 6", "native "+ nationAlliee6 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie6, allieDistanceMin);
	rmSetGroupingMaxDistance(allie6, allieDistanceMax);
	rmAddGroupingToClass(allie6, rmClassID("natives"));
	rmAddGroupingConstraint(allie6, avoidImpassableLand);
	rmAddGroupingConstraint(allie6, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie6, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie6, avoidNatives);
	rmAddGroupingConstraint(allie6, avoidCanyon);
	rmPlaceGroupingAtLoc(allie6, 6, rmPlayerLocXFraction(6), rmPlayerLocZFraction(6));

allie7 = rmCreateGrouping("allie joueur 7", "native "+ nationAlliee7 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie7, allieDistanceMin);
	rmSetGroupingMaxDistance(allie7, allieDistanceMax);
	rmAddGroupingToClass(allie7, rmClassID("natives"));
	rmAddGroupingConstraint(allie7, avoidImpassableLand);
	rmAddGroupingConstraint(allie7, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie7, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie7, avoidNatives);
	rmAddGroupingConstraint(allie7, avoidCanyon);
	rmPlaceGroupingAtLoc(allie7, 7, rmPlayerLocXFraction(7), rmPlayerLocZFraction(7));

allie8 = rmCreateGrouping("allie joueur 8", "native "+ nationAlliee8 + " village "+ villageAspect);
	rmSetGroupingMinDistance(allie8, allieDistanceMin);
	rmSetGroupingMaxDistance(allie8, allieDistanceMax);
	rmAddGroupingToClass(allie8, rmClassID("natives"));
	rmAddGroupingConstraint(allie8, avoidImpassableLand);
	rmAddGroupingConstraint(allie8, avoidTradeRouteSocket);
	// rmAddGroupingConstraint(allie8, avoidPlayersSiEloignes);
	rmAddGroupingConstraint(allie8, avoidNatives);
	rmAddGroupingConstraint(allie8, avoidCanyon);
	rmPlaceGroupingAtLoc(allie8, 8, rmPlayerLocXFraction(8), rmPlayerLocZFraction(8));


	// Text
   rmSetStatusText("", 0.60);


// ************** Amas rocheux (Add Cliffs) **************

   int numTries=0;
   int failCount=0;

	if(oceanRing == 1) // no cliffs for continent
	{
		numTries = 0;
	}
	else if(allLand == 1) // might have lots of cliffs if land
	{
		if(rmRandFloat(0,1) > 0.4)
			numTries = 8*cNumberNonGaiaPlayers;
	}
	else if(plateauMiddle == 1) // might have lots of cliffs if center mesa
	{
		if(rmRandFloat(0,1) > 0.7)
			numTries = 8*cNumberNonGaiaPlayers;
	}
	else
	{
		numTries = 4*cNumberNonGaiaPlayers;
	}
	
		if(rmRandFloat(0,1) < 0.40) // only do cliffs 40% of the time in any case
		{		
			for(i=0; <numTries)
			{
				int smallCliffHeight=rmRandInt(0,10);
				int smallMesaID=rmCreateArea("small cliff "+i);
				rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(400));
				rmSetAreaWarnFailure(smallMesaID, false);
				rmSetAreaCliffType(smallMesaID, cliffName);
				rmAddAreaToClass(smallMesaID, classCanyon);
				rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
				rmSetAreaCliffHeight(smallMesaID, rmRandInt(6,8), 1.0, 1.0);
				rmSetAreaMinBlobs(smallMesaID, 3);
				rmSetAreaMaxBlobs(smallMesaID, 5);
				rmSetAreaMinBlobDistance(smallMesaID, 3.0);
				rmSetAreaMaxBlobDistance(smallMesaID, 5.0);
				rmSetAreaCoherence(smallMesaID, 0.3);
				rmSetAreaSmoothDistance(smallMesaID, 10);
				rmAddAreaConstraint(smallMesaID, avoidCanyon);
				rmAddAreaConstraint(smallMesaID, avoidImpassableLand);
				rmAddAreaConstraint(smallMesaID, avoidPlayers); 
				rmAddAreaConstraint(smallMesaID, avoidNatives); 
				rmAddAreaConstraint(smallMesaID, avoidTradeRouteSocket);
				rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
				if(rmBuildArea(smallMesaID)==false)
				{
					// Stop trying once we fail 3 times in a row.
					failCount++;
					if(failCount==20)
						break;
				}
				else
					failCount=0;
			}
		}
	

// ************** Etangs (Add Ponds) **************


	if(rmRandFloat(0,1) < 0.45)
	{
		rmEchoInfo("ponds exist");
		int numPonds=rmRandInt(2, 5);
		for(i=0; <numPonds)
		{
			int smallPondID=rmCreateArea("small pond "+i);
			rmSetAreaSize(smallPondID, rmAreaTilesToFraction(170), rmAreaTilesToFraction(400));
			rmSetAreaWaterType(smallPondID, pondName);
			rmSetAreaMinBlobs(smallPondID, 1);
			rmSetAreaMaxBlobs(smallPondID, 5);
			rmSetAreaBaseHeight(smallPondID, 4);
			rmSetAreaMinBlobDistance(smallPondID, 5.0);
			rmSetAreaMaxBlobDistance(smallPondID, 70.0);
			rmAddAreaToClass(smallPondID, pondClass);
			rmSetAreaCoherence(smallPondID, 0.5);
			rmSetAreaSmoothDistance(smallPondID, 5);
			rmAddAreaConstraint(smallPondID, pondConstraint);
			rmAddAreaConstraint(smallPondID, avoidPlayers);
			rmAddAreaConstraint(smallPondID, avoidNatives);
			rmAddAreaConstraint(smallPondID, mediumAvoidImpassableLand);
			rmAddAreaConstraint(smallPondID, avoidCanyon);
			rmAddAreaConstraint(smallPondID, edgeConstraint);
			rmAddAreaConstraint(smallPondID, avoidTradeRoute);
			rmSetAreaWarnFailure(smallPondID, false);
			rmBuildArea(smallPondID);
		}
	}

	// Text
   rmSetStatusText("", 0.7);

// ************** Add Forests **************

	numTries=6*cNumberNonGaiaPlayers;
	failCount = 0;
	int sparseForests = -1;

	if(rmRandFloat(0,1) > 0.9)
	{
		numTries = 3*cNumberNonGaiaPlayers;
		rmEchoInfo("sparse forests");
		sparseForests = 1;
	}

   for (i=0; <numTries)
	{   
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(400));
      rmSetAreaForestType(forest, forestName);
      rmSetAreaForestDensity(forest, 0.8);
      rmSetAreaForestClumpiness(forest, 0.6);
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaMinBlobs(forest, 1);
      rmSetAreaMaxBlobs(forest, 5);
      rmSetAreaMinBlobDistance(forest, 16.0);
      rmSetAreaMaxBlobDistance(forest, 70.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 0);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidTC);
      rmAddAreaConstraint(forest, avoidCW);
      rmAddAreaConstraint(forest, avoidAll);
      rmAddAreaConstraint(forest, avoidCanyon);
      rmAddAreaConstraint(forest, mediumAvoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);

      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
	}
	
	// Text
   rmSetStatusText("", 0.8);

// ************** Starting Resources **************


// Silver

	int playerSilverID = rmCreateObjectDef("player silver");
	rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	rmSetObjectDefMinDistance(playerSilverID, 18.0);
	rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	rmAddObjectDefConstraint(playerSilverID, avoidAll);
   rmAddObjectDefConstraint(playerSilverID, shortAvoidImpassableLand);


// baies

	int playerBerryID=rmCreateObjectDef("player berries");
   rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
   rmSetObjectDefMinDistance(playerBerryID, 10);
   rmSetObjectDefMaxDistance(playerBerryID, 15);
	rmAddObjectDefConstraint(playerBerryID, avoidAll);
   rmAddObjectDefConstraint(playerBerryID, shortAvoidImpassableLand);



//arbres proches

	int playerTreeID=rmCreateObjectDef("player trees");
   rmAddObjectDefItem(playerTreeID, treeName, 1, 0.0);
	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
   rmSetObjectDefMinDistance(playerTreeID, 6);
   rmSetObjectDefMaxDistance(playerTreeID, 14);
	rmAddObjectDefConstraint(playerTreeID, avoidAll);
   rmAddObjectDefConstraint(playerTreeID, shortAvoidImpassableLand);



// faune a chasser

   int nearDeerID=rmCreateObjectDef("herds near town");
   rmAddObjectDefItem(nearDeerID, critterOneName, rmRandInt(8,17), 8.0);
   rmSetObjectDefMinDistance(nearDeerID, 20);
   rmSetObjectDefMaxDistance(nearDeerID, 40);
   rmAddObjectDefConstraint(nearDeerID, avoidFood);
	rmAddObjectDefConstraint(nearDeerID, avoidAll);
   rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
   rmSetObjectDefCreateHerd(nearDeerID, true);

	int farDeerID=rmCreateObjectDef("herds far away");
	int bonusChance=rmRandFloat(0, 1);
   if(bonusChance<0.5)   
      rmAddObjectDefItem(farDeerID, critterTwoName, rmRandInt(6,8), 10.0);
   else
      rmAddObjectDefItem(farDeerID, critterTwoName, rmRandInt(9,17), 10.0);
   rmSetObjectDefMinDistance(farDeerID, 100);
   rmSetObjectDefMaxDistance(farDeerID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(farDeerID, avoidFood);
	rmAddObjectDefConstraint(farDeerID, avoidAll);
	if(oceanRing == 1)
		rmAddObjectDefConstraint(farDeerID, avoidPlayers);
	else
		rmAddObjectDefConstraint(farDeerID, avoidPlayersFar);
   rmAddObjectDefConstraint(farDeerID, avoidImpassableLand);
   rmAddObjectDefConstraint(farDeerID, avoidCanyon);
   rmSetObjectDefCreateHerd(farDeerID, true);

	int nugget1= rmCreateObjectDef("nugget easy"); 
	rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
  	rmAddObjectDefConstraint(nugget1, avoidNugget);
  	rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	rmAddObjectDefConstraint(nugget1, avoidAll);
	rmSetObjectDefMinDistance(nugget1, 40.0);
	rmSetObjectDefMaxDistance(nugget1, 60.0);

	int nugget2= rmCreateObjectDef("nugget medium"); 
	rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(2, 2);
	rmSetObjectDefMinDistance(nugget2, 0.0);
	rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
  	rmAddObjectDefConstraint(nugget2, avoidNugget);
  	rmAddObjectDefConstraint(nugget2, avoidTC);
  	rmAddObjectDefConstraint(nugget2, avoidCW);
  	rmAddObjectDefConstraint(nugget2, avoidCanyon);
  	rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
  	rmAddObjectDefConstraint(nugget2, avoidAll);
	rmSetObjectDefMinDistance(nugget2, 80.0);
	rmSetObjectDefMaxDistance(nugget2, 120.0);

	// Define a parm for placing water flags on water maps
	int waterFlagID = -1;
	int placeWaterFlag = -1;

	if (oceanMiddle == 1)
		placeWaterFlag = 1;
	else if (oceanOffCenter == 1)
		placeWaterFlag = 1;
	else if (oceanRing == 1)
		placeWaterFlag = 1;

	// Now place all these definitions

	float bonusSilverChance = rmRandFloat(0,1);
	float bonusTreeChance = rmRandFloat(0,1);
	float bonusNuggetChance1 = rmRandFloat(0,1);
	float bonusNuggetChance2 = rmRandFloat(0,1);
	float berryChance = rmRandFloat(0,1);
	float bonusFoodChance = rmRandFloat(0,1);

	for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();

		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));

		// SILVER
		// Always one silver, but possible for 2 or 3
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusSilverChance > 0.4)
			rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusSilverChance > 0.8)
			rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// TREES
		// Have 4-6 trees, unless sparse
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
 		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusTreeChance > 0.5)
			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusTreeChance > 0.8)
			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		// If sparse forests, add extra trees
		if (sparseForests == 1)
		{
			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
 			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
			rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		}

		// NUGGETS
		// Always 1 of type I. Can have +1 or +2 of type I and +1 or +2 of type II
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusNuggetChance1 > 0.5)
			rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusNuggetChance1 > 0.9)
			rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusNuggetChance2 > 0.8)
			rmPlaceObjectDefAtLoc(nugget2, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusNuggetChance2 > 0.95)
			rmPlaceObjectDefAtLoc(nugget2, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		// FOOD
		// Always 1 near and 1 far. Sometimes +1 or +2 far.
		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusFoodChance > 0.70)
			rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if (bonusFoodChance > 0.90)
			rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		// BERRIES
		// 30% of the time
		if (berryChance > 0.7)
			rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		// WATER FLAG
		// If it can't place it within 0.2, it tries again at 0.7
		if (placeWaterFlag == 1)
		{
			waterFlagID=rmCreateObjectDef("HC water flag "+i);
			rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		   rmAddObjectDefConstraint(waterFlagID, edgeConstraint);
			rmAddObjectDefConstraint(waterFlagID, flagVsFlag);
			rmAddObjectDefConstraint(waterFlagID, fishLand);
			rmAddObjectDefConstraint(waterFlagID, pondConstraint);

			rmSetObjectDefMinDistance(waterFlagID, 0.0);
			rmSetObjectDefMaxDistance(waterFlagID, rmXFractionToMeters(0.2));
			rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
			if(rmGetNumberUnitsPlaced(waterFlagID) < 1)
			{
				rmEchoInfo("------- FAILED TO PLACE WATER FLAG "+i+". RELAXING CONSTRAINTS");
				rmSetObjectDefMaxDistance(waterFlagID, rmXFractionToMeters(0.7));
				rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
			}	
		}
	}


	// Text
   rmSetStatusText("", 0.9);


// ************** Other Resources **************

// Silver

	int silverID = -1;
	int silverCount = (cNumberNonGaiaPlayers*2 + rmRandInt(3,6));
	rmEchoInfo("silver count = "+silverCount);

	for(i=0; < silverCount)
	{
      silverID = rmCreateObjectDef("silver "+i);
	   rmAddObjectDefItem(silverID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverID, 0.0);
      rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidSilver);
      rmAddObjectDefConstraint(silverID, avoidAll);
		if(oceanRing == 1)
			rmAddObjectDefConstraint(silverID, avoidPlayers);
		else
			rmAddObjectDefConstraint(silverID, avoidPlayersFar);
      rmAddObjectDefConstraint(silverID, avoidImpassableLand);
      rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }

// Livestock

	int sheepID=rmCreateObjectDef("livestock");
	rmAddObjectDefItem(sheepID, livestockName, 2, 4.0);
	rmSetObjectDefMinDistance(sheepID, 0.0);
	rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(sheepID, avoidFood);
	rmAddObjectDefConstraint(sheepID, avoidAll);
	if(oceanRing == 1)
		rmAddObjectDefConstraint(sheepID, avoidPlayers);
	else
		rmAddObjectDefConstraint(sheepID, avoidPlayersFar);
	rmAddObjectDefConstraint(sheepID, avoidCanyon);
	rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	if(rmRandFloat(0,1) > 0.85)
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

// Treasures

	int nugget3= rmCreateObjectDef("nugget hard"); 
	rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(3, 3);
	rmSetObjectDefMinDistance(nugget3, 0.0);
	rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
  	rmAddObjectDefConstraint(nugget3, avoidNugget);
  	rmAddObjectDefConstraint(nugget3, avoidPlayersFar);
  	rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
  	rmAddObjectDefConstraint(nugget3, avoidAll);
	if(rmRandFloat(0,1) < 0.9)
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
	else
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers*rmRandInt(2,4));

	if (rmRandFloat(0,1) > 0.9)
	{
		int nugget4= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nugget4, 0.0);
		rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(nugget4, avoidNugget);
  		rmAddObjectDefConstraint(nugget4, avoidPlayersFar);
  		rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
  		rmAddObjectDefConstraint(nugget4, avoidAll);
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, rmRandInt(0,5));
	}


// add fish if ocean
	if (placeWaterFlag == 1)
	{
		int fishID=rmCreateObjectDef("fish");
		rmAddObjectDefItem(fishID, fishName, 1, 0.0);
		rmSetObjectDefMinDistance(fishID, 0.0);
		rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fishID, fishVsFishID);
		rmAddObjectDefConstraint(fishID, fishLand);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

		int whaleID=rmCreateObjectDef("whale");
		rmAddObjectDefItem(whaleID, whaleName, 1, 9.0);
		rmSetObjectDefMinDistance(whaleID, 0.0);
		rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
		rmAddObjectDefConstraint(whaleID, whaleLand);
		if(rmRandFloat(0,1) < 0.5)
			rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
	}



//        ***********  gestion du jour et de la nuit (day and night light management) **********


	// choix des lumires (choice of lights)

	string LumiereLight1 = "minescene";
	string LumiereLight2 = "201a";
	string LumiereLight3 = "316a_russians";
	string LumiereLight4 = "spc14anight";

	int choixmatin = rmRandInt (1,4);	
	if (choixmatin == 2)
	LumiereLight1 = "301a_malta";
	if (choixmatin == 3)
	LumiereLight1 = "bayou";
	if (choixmatin == 4)
	LumiereLight1 = "amsterdam evening";

	int choixjournee = rmRandInt (1,3);
	if (choixjournee == 2)
	LumiereLight2 = "default";
	if (choixjournee == 3)
	LumiereLight2 = "amsterdam";
	
	int choixsoir = rmRandInt (1,2);
	if (choixsoir == 2)
	LumiereLight3 = "308b_caribbeanlight";

	int choixnuit = rmRandInt (1,2);
	if (choixnuit == 2)	
	LumiereLight4 = "302b_cavelighting";

bool actif2 = false;
bool actif3 = false;
bool actif4 = false;

int demarrage = rmRandInt (1,3);

if (demarrage == 1)
{ 
rmSetLightingSet(LumiereLight1); 
actif2 = true;
}

if (demarrage == 2)
{ 
rmSetLightingSet(LumiereLight2); 
actif3 = true;
}

if (demarrage == 3)
{ 
rmSetLightingSet(LumiereLight3); 
actif4 = true;
}

//debut des declencheurs (triggers)

rmCreateTrigger("Lumiere1");
rmCreateTrigger("Lumiere2");
rmCreateTrigger("Lumiere3");
rmCreateTrigger("Lumiere4");
rmCreateTrigger("neige");
rmCreateTrigger("pluie");
rmCreateTrigger("beau");


//MATIN    MORNING
rmSwitchToTrigger(rmTriggerID("Lumiere1"));
rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamFloat("Param1",DureeLumiere*2);
rmAddTriggerEffect("Set Lighting");
rmSetTriggerEffectParam("SetName",LumiereLight1);
rmSetTriggerEffectParamFloat("FadeTime",DureeTransition);
rmAddTriggerEffect("Fire Event");
rmSetTriggerEffectParamInt("EventID",rmTriggerID("Lumiere2"));
rmSetTriggerPriority(4);
rmSetTriggerActive(false);
rmSetTriggerRunImmediately(false);
rmSetTriggerLoop(false);

//JOURNEE    DAY
rmSwitchToTrigger(rmTriggerID("Lumiere2"));
rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamFloat("Param1",DureeLumiere);
rmAddTriggerEffect("Set Lighting");
rmSetTriggerEffectParam("SetName",LumiereLight2);
rmSetTriggerEffectParamFloat("FadeTime",DureeTransition);
rmAddTriggerEffect("Fire Event");
rmSetTriggerEffectParamInt("EventID",rmTriggerID("Lumiere3"));
rmSetTriggerPriority(4);
rmSetTriggerActive(actif2);
rmSetTriggerRunImmediately(actif2);
rmSetTriggerLoop(false);


// SOIR   EVENING
rmSwitchToTrigger(rmTriggerID("Lumiere3"));
rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamFloat("Param1",DureeLumiere*2);
rmAddTriggerEffect("Set Lighting");
rmSetTriggerEffectParam("SetName",LumiereLight3);
rmSetTriggerEffectParamFloat("FadeTime",DureeTransition);
rmAddTriggerEffect("Fire Event");
rmSetTriggerEffectParamInt("EventID",rmTriggerID("Lumiere4"));
rmSetTriggerPriority(4);
rmSetTriggerActive(actif3);
rmSetTriggerRunImmediately(actif3);
rmSetTriggerLoop(false);

// NUIT   
rmSwitchToTrigger(rmTriggerID("Lumiere4"));
rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamFloat("Param1",DureeLumiere);
rmAddTriggerEffect("Set Lighting");
rmSetTriggerEffectParam("SetName",LumiereLight4);
rmSetTriggerEffectParamFloat("FadeTime",DureeTransition);
rmAddTriggerEffect("Fire Event");
rmSetTriggerEffectParamInt("EventID",rmTriggerID("Lumiere1"));
rmSetTriggerPriority(4);
rmSetTriggerActive(actif4);
rmSetTriggerRunImmediately(actif4);
rmSetTriggerLoop(false);



// jour nuit fin (day night end)



//pluie (rain)

if (amazonMap == 1 || carolinaMap == 1 || saguenayMap ==1)
{
rmSwitchToTrigger(rmTriggerID("pluie"));
rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamFloat("Param1",rmRandFloat(15,2000));
rmAddTriggerEffect("Render Rain");
rmSetTriggerEffectParamFloat("Percent",rmRandFloat(10,99));
rmSetTriggerPriority(1);
rmSetTriggerActive(true);
rmSetTriggerRunImmediately(true);
rmSetTriggerLoop(true);
}

//neige (snow)

if (rockiesMap == 1 || carolinaMap == 1 || saguenayMap ==1)
{
rmSwitchToTrigger(rmTriggerID("neige"));
rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamFloat("Param1",rmRandFloat(25,3500));
rmAddTriggerEffect("Render Snow");
rmSetTriggerEffectParamFloat("Percent",rmRandFloat(5,99));
rmSetTriggerPriority(1);
rmSetTriggerActive(true);
rmSetTriggerRunImmediately(true);
rmSetTriggerLoop(true);
}

//beau temps (good weather return)
rmSwitchToTrigger(rmTriggerID("beau"));
rmAddTriggerCondition("Timer");
rmSetTriggerConditionParamFloat("Param1",rmRandFloat(15,500));
rmAddTriggerEffect("Render Snow");
rmSetTriggerEffectParamFloat("Percent",0);
rmAddTriggerEffect("Render Rain");
rmSetTriggerEffectParamFloat("Percent",0);
rmSetTriggerPriority(1);
rmSetTriggerActive(true);
rmSetTriggerRunImmediately(true);
rmSetTriggerLoop(true);



  // Text
   rmSetStatusText("",1.0);




}
